
/*****************************************************

Chip type               : ATmega328p
Program type            : Application
AVR Core Clock frequency: 8,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
   UR3QQW    SI5351A.   UR3QQW_Si5351A.
   CD4094.
 ,    , , AGC, AMP.   "".
 ,    ,  . !     -  {}      While
      .      - . 
 !!!       ,    . ,   12.11.2017 .
   9.03.2018 .    AVR Studio 4.19.
*****************************************************/


#include <avr/pgmspace.h>


#include <stdlib.h>



#include "si5351a.h"
#include "i2c.h"
//#include "si5351a.c"
//#include "i2c.c"
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/sfr_defs.h>
#include <stdio.h>
#include <math.h>
#include <util/delay.h>
//#include "encoder2.c"
#include "main.h"
//#include "ldc.c"
#define StartConvAdc() ADCSRA |= (1<<ADSC)
#define StopConvAdc()   ADCSRA &=~(_BV(ADSC))  

#define Clock              PINC1
#define Data               PINC2
#define Strobe             PINC3
#define BandPinPort        PIND
#define TCNT0_const 0
#define TCCR0_const 5

char    r;
char    l;
char    t;

int     chagi=10;

volatile unsigned int AdcBuf;
volatile unsigned long Adc_1;
volatile unsigned char mode;
volatile  signed int bufEnc = 0;                     // 

unsigned long frequency, frequency_r, frequency_t; 
volatile unsigned long pllFreq=798291000;
                     

long rit; 
	
float freq;

char _band, band_2, bit, chip_593, chip_593_1, chip_593_band, rit_1,n;    

typedef unsigned char byte;

/************      *******************/ 

unsigned long    freq_max[9]={29000000,21450000,14350000,18168000,2000000,3800000,10150000,7100000}; 
unsigned long    freq_min[9]={28000000,21000000,14000000,18068000,1830000,3500000,10100000,7000000};
unsigned long frequency_1[9]={28000000,21000000,14000000,18068000,1830000,3500000,10100000,7000000}; 


 // ++++    ++++
void initialization(void)

{
PORTB=0xE7;
DDRB=0x00;
PORTC=0x3E;
DDRC=0x00;
PORTD=0x7C;
DDRD=0x80;
MCUCR = (0<<PUD);

//External Interrupt(s) initialization
//INT0: On
//INT0 Mode: Falling Edge
//INT1: Off
//EICRA=0x03;      // ,   ,   
//EIMSK=0x01;      //  ,    INT0
//EIFR=0x01;
//PCICR=0x00;


 // 
 
 //. ,   ,  ,  . = FCPU/128
   
DIDR0=0x00;
ADMUX = (0<<REFS1)|(1<<REFS0)|(0<<ADLAR)|(0<<MUX3)|(0<<MUX2)|(0<<MUX1)|(0<<MUX0);
ADCSRA=(1<<ADEN)|(0<<ADSC)|(0<<ADATE)|(0<<ADIF)|(0<<ADIE)|(1<<ADPS2)|(1<<ADPS1)|(1<<ADPS0); 
ADCSRB&=0xF8; 


// 

TCNT0 = TCNT0_const; //     
TCCR0B = TCCR0_const; //    =1024
TIMSK0 = (1<<TOIE0);  //    
}
  
ISR(TIMER0_OVF_vect)

{
  
  t=1; //    
}
 
  
/*********************    *******/        
  void band (void) 
{
band_2=_band;
{ 
PORTB &=~(_BV(PB5));
PORTD &=~(_BV(PD5));

  char t;
       	
       for (t=0; t<8; t++)	  		
      
       { PORTD |=_BV(PD6);  
        //_delay_us(2);     
         PORTD &=~(_BV(PD6));
		//_delay_us(2);
       } 
   PORTB |=_BV(PB5);	   
  _band=0;
   
   PORTD |=_BV(PD5);

do
 {
         PORTD |=_BV(PD6);  
        //_delay_us(2);     
         PORTD &=~(_BV(PD6));
		//_delay_us(2);
		_band++;
      if (_band>7)	break;
 
 } 
 
  while(( BandPinPort & 0b10000000)==0);  //   D5 1,   
   
 } 
   _band--;	

switch(_band)
	
	{
	case 0: chip_593_band=0b00000001; break;
	case 1: chip_593_band=0b00000010; break;
	case 2: chip_593_band=0b00000100; break;
	case 3: chip_593_band=0b00001000; break;
	case 4: chip_593_band=0b00010000; break;
	case 5: chip_593_band=0b00100000; break;	
	case 6: chip_593_band=0b01000000; break;
	case 7: chip_593_band=0b10000000; break;	
	
	}
  
	
	if (_band!=band_2)  
   {
   
   k595_init(chip_593_band);   //  	
    k595_init(chip_593);       //  
	 PORTD |=_BV(PD3); 
      _delay_us(2);
       PORTD &=~(_BV(PD3)); 
        frequency = (frequency_1[(int)_band]);
         frequency_t = frequency; 
         lcd_init(frequency);
	       si5351aSetFrequency(frequency);  
 }    
 
 }    

/********************    **************/

void sub_freg()                   

 
{
frequency =frequency_t;
 if (rit_1==0)                 

{ 
   //frequency =frequency_t; 
   frequency=frequency+chagi*bufEnc*abs(bufEnc);
   
   if (frequency > (freq_max[(int)_band]))    frequency=(freq_min[(int)_band]);
   if (frequency < (freq_min[(int)_band]))    frequency=(freq_max[(int)_band]);
      frequency_t=frequency;
      }
 else  
 {
          rit=rit+chagi*bufEnc;
              frequency=frequency+rit;
      }	  	  
      } 

   

/*************************    *************************/
void Key_kontr()

{
 
  chip_593_1= chip_593;
   
  ADCSRA |= (1<<ADSC);                                        //  .
    while ((ADCSRA&(1 << ADIF))== 0);                        //    
   {
   }  
    
        AdcBuf = ADC;                                            //     
   	  
  if (AdcBuf<1000)                                               //    - 
 {
    n=1;
 
    }
 
    } 
 
/*******************      ******************/
 void Key_1()
  
{
_delay_ms(5);  
 ADCSRA |= (1<<ADSC); 
   while ((ADCSRA&(1 << ADIF))== 0);           //   
   {
   }
    
   AdcBuf = ADC;                                //     
    
	  Adc_1=ADC;  
	    Key_2();
  
{
	
  if      (Adc_1 < 107)  l=6;	                        //MENU  -   
  else if (Adc_1 < 224)   l=7;                         //IF
  else if (Adc_1 < 372)    l=5;                        //AMP  
  else if (Adc_1 < 519)     l=4;                       //ATT
  else if (Adc_1 < 683)      l=3;                      //AGC
  else if (Adc_1 < 846)       l=1;                     //FAST 
  else if (Adc_1 < 974)        l=2;                    //RIT  
  else l=8;	

chip_593=chip_593^(1<<l);

 if (chip_593_1!=chip_593)

  {
  k595_init(chip_593_band);   //  
       k595_init(chip_593);   //  
	     PORTD |=_BV(PD3); 
          _delay_us(2);
             PORTD &=~(_BV(PD3));  
  
 if ((unsigned char)chip_593&0b00000100)
 
        rit_1=1;                                          // 
  else
  {
  rit_1=0;
  rit=0;
  frequency_t =frequency;
     }
    
 if ((unsigned char)chip_593&0b00000010)                  //  
       chagi=1000;
  else chagi=10;  
   
 if ((unsigned char)chip_593&0b10000000)       mode=1;    //  
     else mode=0;  
   	    
     si5351aSetFreq_op(mode);                         //  
    }
    }        
	}
 
 /***********************    ************************/
 void Key_2()
 {
 do
 {
  ADCSRA |= (1<<ADSC);                                       //  .
   while ((ADCSRA&(1 << ADIF))== 0);           //   
   {
   }
    
    AdcBuf = ADC;                               //              
      
	
 } 
  while (AdcBuf<1000);                                    //   - 
 } 
 
 /**********************   *******************/
 void tx(void)
 {
 si5351aSetFrequency(frequency_t);
 lcd_init(frequency_t);
 do
 {      
  
 } 
  while (bit_is_clear(PIND, 6)); //   -  
 
   
   si5351aSetFrequency(frequency);
    lcd_init(frequency);
  
 }
 
 /***************   **************/
  
 void k595_init(char m)
 {

unsigned char i; 
unsigned char tmp;

PORTD &=~(_BV(PD3));  //  

tmp = m;                        

for (i = 0; i < 8; i++)
 { 
if (tmp & 0x80) 
{PORTD |=_BV(PD1);}    else   {PORTD &=~(_BV(PD1));}
//_delay_ms(1);

PORTD |=_BV(PD4);                // 
//_delay_ms(1);

PORTD &=~(_BV(PD4)); 
tmp <<= 1;                       //    

   } 
 //PORTD |=_BV(PD3);     
} 
 
 
/************    *******************/                
int main(void)
{
initialization();
 i2cInit();
  chip_593=0b00000000;
   
   band();
	k595_init(chip_593_band);   //  
      k595_init(chip_593);   //  
	   PORTD |=_BV(PD3);
        //_delay_us(2);
          PORTD &=~(_BV(PD3));   
       frequency = (frequency_1[(int)_band]);
       lcd_init(frequency);
	     si5351aSetFrequency(frequency);
		   si5351aSetFreq_op(0);                         //  
	        //si5351aOutputOff(18); //      CLK2.  - 18 . 7   .
              TCNT0 =  TCNT0_const;        // 
 sei();
             
while (1)                     // 
{
if (bit_is_clear(PIND, 6))    tx(); 

PollEncoder();                          
 
if (t!=0)                             //   , .  
{ 
if (bufEnc!=0)
{ 
 cli();                                // 
 sub_freg();                            
   bufEnc=0;                             //                         
    lcd_init(frequency);
       si5351aSetFrequency(frequency); 
  }  
  
band();   

Key_kontr();
/*******************************************************************/  
if (n==1)
{
Key_1();
    n=0;

  }
/*******************************************************************/
  
   
 t=0;
 TCNT0 =  TCNT0_const;                  //  
 sei();                                 //  
  }

  }

  }

